/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2015 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_syssvc.h 1087 2015-02-03 01:04:34Z ertl-honda $
 */

/*
 *  ƥॵӥΥåװ¸AT91SKYEYEѡ
 *
 *  ƥॵӥΥåװ¸Υ󥯥롼ɥե롥Υե
 *  Ƥϡݡͥȵҥե˵Ҥ졤Υե̵ʤ
 *  ߡ
 */

#ifndef TOPPERS_TARGET_SYSSVC_H
#define TOPPERS_TARGET_SYSSVC_H

#include "at91skyeye.h"

/*
 *  ȥ졼˴ؤ
 */
#ifdef TOPPERS_ENABLE_TRACE
#include "logtrace/trace_config.h"
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ưåΥåȥƥ̾
 */
#define TARGET_NAME    "AT91SKYEYE(ARM)"

/*
 *  ƥ٥ϤΤʸ
 *
 *  åȰ¸ˡǡʸcɽ//¸롥
 */
extern void	target_fput_log(char c);

#ifdef TOPPERS_ENABLE_TRACE
/*
 *  ȥ졼Υե
 */
extern void	target_fput_log_file(char c);
#endif /* TOPPERS_ENABLE_TRACE */

/*
 *  ꥢݡȿ
 */
#define TNUM_PORT    TNUM_PRCID    /* ݡȤ륷ꥢݡȤο */

/*
 *  ƥϢ
 *
 *  ǥե̤ͤꡥ
 */

/*
 *  ƥѤѿΥ
 */
#define SEC_LOGTASK(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc1p_logtask"),nocommon))
#define SEC_PRC1_LOGTASK(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc1p_logtask"),nocommon))
#define SEC_PRC2_LOGTASK(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc2p_logtask"),nocommon))
#define SEC_PRC3_LOGTASK(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc3p_logtask"),nocommon))
#define SEC_PRC4_LOGTASK(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc4p_logtask"),nocommon))

/*
 *  ꥢ륤󥿥եɥ饤ФѤѿΥ
 */
#define SEC_SERIAL1(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc1p_serial"),nocommon))
#define SEC_SERIAL2(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc2p_serial"),nocommon))
#define SEC_SERIAL3(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc3p_serial"),nocommon))
#define SEC_SERIAL4(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc4p_serial"),nocommon))

/*
 *  ƥǽѤѿΥ
 */
#define SEC_SYSLOG(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc1p_syslogcb"),nocommon))
#define SEC_PRC1_SYSLOG(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc1p_syslogcb"),nocommon))
#define SEC_PRC2_SYSLOG(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc2p_syslogcb"),nocommon))
#define SEC_PRC3_SYSLOG(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc3p_syslogcb"),nocommon))
#define SEC_PRC4_SYSLOG(type, variable) \
			type variable __attribute__((section(".bss._kernel_prc4p_syslogcb"),nocommon))

#endif /* TOPPERS_TARGET_SYSSVC_H */
